# -*- coding: utf-8 -*-

import sys
import time
import math
import types
import PyQt5.QtCore as core
import PyQt5.QtGui as gui
import PyQt5.QtWidgets as widgets
import PyQt5.uic as uic

class Tracker(core.QObject):
    def eventFilter(self, receiver, event):
        if event.type() == core.QEvent.MouseMove:
            track.append( (event.x(), event.y(), time.clock()) )
            w.label_2.setText(str(event.x()) + " " + str(event.y()) + " " + str(len(track)))
        return False

def showDiagram(istAn):
    if istAn:
        w.label.show()
    else:
        w.label.hide()

pn = gui.QPen()

br = gui.QBrush()
br.setStyle(core.Qt.SolidPattern)

def paintDiagram(self, event):
    painter = gui.QPainter(self)
    for i in range(len(track)-1):
        (x,y,t) = track[i]
        (x1,y1,t1) = track[i+1]
        dt = t1 - t
        v = math.sqrt((x1-x)**2 + (y1-y)**2)/(dt + 0.00001)
        if v > 2000.0:
            pn.setColor(gui.QColor(0, 0, 255, 128))
            painter.setPen(pn)
            painter.drawLine(x, y, x1, y1)
        else:
            alpha = 255.0/2.0*dt
            if alpha > 255.1:
                alpha = 255.1
            br.setColor(gui.QColor(255, 120, 120, alpha))
            painter.setBrush(br)
            pn.setColor(core.Qt.transparent)
            painter.setPen(pn)
            painter.drawEllipse(x-40, y-40, 80, 80)

track = []

app = widgets.QApplication(sys.argv)
w = uic.loadUi("tracker.ui")

myTracker = Tracker()
w.webView.installEventFilter(myTracker)
w.webView.setMouseTracking(True)

w.label.hide()
w.label.paintEvent = types.MethodType(paintDiagram, w.label)
w.checkBox.toggled.connect(showDiagram)

w.show()
sys.exit(app.exec_())